/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package ch.sahits.javafx.test;

import javafx.beans.property.DoubleProperty;
import javafx.beans.property.ObjectProperty;
import javafx.beans.property.SimpleDoubleProperty;
import javafx.beans.property.SimpleObjectProperty;
import javafx.scene.control.Control;
import javafx.scene.image.Image;

/**
 *
 * @author andi
 */
public class MyCanvas extends Control {
    private final ObjectProperty<Image> image;
    private final DoubleProperty localWidth;
    private final DoubleProperty localHeight;

    public MyCanvas() {
        this(null, 0, 0);
    }
    
    public MyCanvas(double width, double height) {
        this(null, width, height);
    }
    public MyCanvas(Image img, double width, double height) {
        this.getStyleClass().add(this.getClass().getSimpleName());
        if (width <= 0) {
            width = getWidth();
        }
        if (height <= 0) {
            height = getHeight();
        }
        image = new SimpleObjectProperty<>(this, "image", img);
        localWidth = new SimpleDoubleProperty(this,"local-width", width);
        localHeight = new SimpleDoubleProperty(this, "local-height", height);
    }
    @Override
    protected String getUserAgentStylesheet() {
        return getClass().getResource("/ch/sahits/javafx/test/"+getClass().getSimpleName()+".css").toExternalForm();
    }


    public Image getImage() {
        return image.getValue();
    }
    
    public void setImage(Image img) {
        image.setValue(img);
    }
    
    public ObjectProperty<Image> imageProperty(){
        return image;
    }
        public double getLocalWidth(){
        return localWidth.doubleValue();
    }
    
    public void setLocalWidth(double width){
        localWidth.setValue(width);
    }
    
    public DoubleProperty localWidthProperty() {
        return localWidth;
    }
    public double getLocalHeight(){
        return localHeight.doubleValue();
    }
    
    public void setLocalHeigth(double heigth){
        localHeight.setValue(heigth);
    }
    
    public DoubleProperty localHeigthProperty() {
        return localHeight;
    }
    
}
