/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package ch.sahits.javafx.test;

import javafx.beans.value.ChangeListener;
import javafx.beans.value.ObservableValue;
import javafx.scene.canvas.Canvas;
import javafx.scene.canvas.GraphicsContext;
import javafx.scene.control.SkinBase;
import javafx.scene.image.Image;


/**
 *
 * @author andi
 */
public class MyCanvasSkin extends SkinBase<MyCanvas> {
    
    private final Canvas canvas;
    
    public MyCanvasSkin(MyCanvas control) {
        super(control);
        canvas = new Canvas(control.getLocalWidth(), control.getLocalHeight());
        createChangeListeners();
        
        this.getChildren().add(canvas);
     }

    private void createChangeListeners() {
        MyCanvas myCanvas = getSkinnable();
        ResizeChangeListener resizeListener = new ResizeChangeListener();
        myCanvas.localHeigthProperty().addListener(resizeListener);
        myCanvas.localWidthProperty().addListener(resizeListener);
        myCanvas.imageProperty().addListener(new ChangeListener<Image>(){

            @Override
            public void changed(ObservableValue<? extends Image> ov, Image t, Image t1) {
                final GraphicsContext context = canvas.getGraphicsContext2D();
                final double width = getSkinnable().getLocalWidth();
                final double height = getSkinnable().getLocalHeight();
                context.clearRect(0, 0, width, height);
                context.drawImage(getSkinnable().getImage(), 0, 0, width, height);
            }
            
        });
    }
    
        private class ResizeChangeListener implements ChangeListener<Number> {
        
        private final GraphicsContext context;

        public ResizeChangeListener() {
            this.context = canvas.getGraphicsContext2D();
        }

        @Override
        public void changed(ObservableValue<? extends Number> observable, Number oldValue, Number newValue) {
            final MyCanvas myCanvas = getSkinnable();
            final double width = myCanvas.getLocalWidth();
            final double height = myCanvas.getLocalHeight();
            context.clearRect(0, 0, width, height);
            if (myCanvas.getImage() != null ) {
                context.drawImage(myCanvas.getImage(), 0, 0, width, height);
                System.out.println("Draw image");
            } else {
                System.out.println("Image not set");
            }
        }
    }
}
