/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package ch.sahits.javafx.test;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javafx.application.Application;
import javafx.beans.value.ChangeListener;
import javafx.beans.value.ObservableValue;
import javafx.scene.Scene;
import javafx.scene.canvas.Canvas;
import javafx.scene.canvas.GraphicsContext;
import javafx.scene.image.Image;
import javafx.scene.layout.Pane;
import javafx.scene.layout.StackPane;
import javafx.stage.Stage;

/**
 *
 * @author andi
 */
public class ResizeableCanvas extends Application {
    
    @Override
    public void start(Stage primaryStage) {
        try {
            StackPane root = new StackPane();
            Scene scene = new Scene(root, 300, 250);
            Image img = new Image(getClass().getResource("kajak4_small.png").openStream());
            Canvas canvas = new Canvas(root.getWidth(), root.getHeight());
            GraphicsContext context = canvas.getGraphicsContext2D();
            context.drawImage(img, 0, 0, root.getWidth(), root.getHeight());
            
            // Binding
            canvas.widthProperty().bind(root.widthProperty());
            canvas.heightProperty().bind(root.heightProperty());
            
            final ResizeChangeListener resizeChangeListener = new ResizeChangeListener(root, context, img);
            
            canvas.widthProperty().addListener(resizeChangeListener);
            canvas.heightProperty().addListener(resizeChangeListener);
           
            root.getChildren().add(canvas);            
            
            primaryStage.setTitle("Resizable Canvas Test");
            primaryStage.setScene(scene);
            primaryStage.show();
        } catch (IOException ex) {
            Logger.getLogger(ResizeableCanvas.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    /**
     * The main() method is ignored in correctly deployed JavaFX application.
     * main() serves only as fallback in case the application can not be
     * launched through deployment artifacts, e.g., in IDEs with limited FX
     * support. NetBeans ignores main().
     *
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        launch(args);
    }

    private static class ResizeChangeListener implements ChangeListener<Number> {
        
        private final Pane parent;
        private final GraphicsContext context;
        private final Image img;

        public ResizeChangeListener(Pane parent, GraphicsContext context, Image image) {
            this.parent = parent;
            this.context = context;
            this.img = image;
        }

        @Override
        public void changed(ObservableValue<? extends Number> observable, Number oldValue, Number newValue) {
            final double width = parent.getWidth();
            final double height = parent.getHeight();
            context.clearRect(0, 0, width, height);
            context.drawImage(img, 0, 0, width, height);
        }
    }
}
